<template>
  <div class="weight-scales">
    <div class="weight-scales-inner">
      <div class="scale-svg-1 svg-outer" :style="svgStyle">
        <svg viewBox="0 0 400 400" xmlns="http://www.w3.org/2000/svg">
          <circle
            cx="200"
            cy="200"
            r="194.5"
            fill="white"
            style="filter:url(#dropshadow)"
          />

          <path
            v-for="(section, i) in sections"
            :key="`path_${i}`"
            v-bind="section.area"
          />

          <text
            v-for="(section, i) in sections"
            :key="`text_${i}`"
            x="200"
            y="200"
            fill="white"
            alignment-baseline="middle"
            text-anchor="middle"
            :transform="section.textTransform"
          >
            {{ section.content }}
          </text>

          <circle
            cx="200"
            cy="200"
            r="140"
            fill="#fff"
            style="filter:url(#dropshadow)"
          />

          <path
            transform="rotate(92, 200, 200) translate(200, 200) scale(0.8 0.8) translate(-200, -200)"
            d="M114.154 250.59l-29.683 17.73 1.054 1.697 29.683-17.73-1.054-1.696zm-7.221-15.026l-32.179
            12.58.76 1.903 32.178-12.58-.76-1.903zM102.3 219.41l-33.86 6.998.406 1.979
            33.86-6.998-.406-1.98zm-1.89-16.582l-34.617 1.243.055 2.055
            34.616-1.243-.055-2.055zm.929-16.658l-34.296-4.52-.26 2.04 34.295
            4.52.26-2.04zm3.733-16.418l-33.101-10.047-.54 1.93 33.102 10.047.54-1.93zm-24.655-30.833l-.912
            1.785 30.996 15.433.912-1.784-30.996-15.434zm11.782-19.16l-1.192 1.676 27.997 20.362
            1.191-1.675L92.2 119.758zm14.957-16.848l-1.435 1.473 24.138 24.742
            1.435-1.473-24.138-24.742zm37.258 14.24l-19.68-28.459-1.641 1.178 19.68 28.46
            1.64-1.178zm14.551-8.121L144.27 77.7l-1.848.884 14.695 31.328
            1.848-.883zm15.817-5.594l-9.276-33.385-1.925.532 9.22 33.256
            1.981-.403zm16.472-2.875l-3.532-34.352-2.002.181 3.532 34.352
            2.002-.181zm16.775-.08l2.424-34.487-1.987-.134-2.424 34.486 1.987.134zm16.54
            2.717l7.887-33.635-1.971-.45-7.887 33.636 1.97.45zm15.766 5.52l13.676-31.694-1.826-.82-13.676
            31.693 1.826.821zm14.694 7.991l18.821-28.933-1.717-1.1-18.821 28.934 1.717 1.099zm13.082
            10.466l23.455-25.41-1.515-1.342-23.455 25.41 1.515 1.342zm11.243 12.423L306.8
            118.53l-1.183-1.64-27.446 21.067 1.183 1.64zm8.94 14.2l30.588-16.2-.925-1.753-30.588 16.199.925
            1.753zm6.409 15.457l32.824-10.936-.63-1.959-32.824 10.936.63 1.959zm3.836
            16.272l34.154-5.277-.278-2.036-34.154 5.278.278 2.035zm35.652 17.253l.038-2.019-34.559-.554-.037
            2.02 34.558.553zm-2.066 20.389l-34.052-6.244-.353 2.003 34.052 6.244.353-2.003zm-5.673
            21.654l-32.542-11.755-.632 1.894 32.541 11.755.633-1.894zm-39.384 3.555l-1.005 1.748 30.157 17.033
            1.005-1.749-30.157-17.032zm16.268 37.189l1.248-1.546-26.877-21.852-1.248 1.546 26.877 21.852zm-15.743
            16.113l1.492-1.344-22.906-25.973-1.491 1.344 22.905 25.973zm-36.403-16.155l18.241 29.396
            1.698-1.049-18.24-29.396-1.699 1.05zm-15.114 7.367l13.012 32.063 1.905-.755-13.013-32.062-1.904.754zm-16.029
            4.761l7.517 33.769 1.982-.403-7.517-33.768-1.982.402zm-16.554 1.987l1.659 34.476
            2.06-.051-1.66-34.476-2.059.051zm-16.764-.771l-4.188 34.332 2.044.263 4.188-34.332-2.044-.263zm-16.27-3.683l-9.821
            33.093 1.934.542 9.822-33.093-1.934-.542zm-15.569-6.3l-15.315 30.947 1.79.913L156.68
            289.8l-1.79-.913zm-14.273-8.79l-20.353 27.907 1.681 1.192 20.352-27.907-1.68-1.192zm-12.513-11.1l-24.747
            24.05 1.479 1.434 24.747-24.049-1.479-1.434z"
            fill="#f0f0f0"
          />
        </svg>
      </div>
      <div class="scale-svg-2 svg-outer">
        <svg viewBox="0 0 400 400" xmlns="http://www.w3.org/2000/svg">
          <filter id="dropshadow" height="130%">
            <feGaussianBlur in="SourceAlpha" stdDeviation="2" />
            <feOffset dx="0" dy="0" result="offsetblur" />
            <feComponentTransfer>
              <feFuncA type="linear" slope="0.6" />
            </feComponentTransfer>
            <feMerge>
              <feMergeNode />
              <feMergeNode in="SourceGraphic" />
            </feMerge>
          </filter>

          <filter id="dropshadow-2" height="130%">
            <feGaussianBlur in="SourceAlpha" stdDeviation="2" />
            <feOffset dx="0" dy="0" result="offsetblur" />
            <feComponentTransfer>
              <feFuncA type="linear" slope="0.4" />
            </feComponentTransfer>
            <feMerge>
              <feMergeNode />
              <feMergeNode in="SourceGraphic" />
            </feMerge>
          </filter>
          <circle
            cx="200"
            cy="200"
            r="110"
            fill="#e8e7e7"
            style="filter:url(#dropshadow-2)"
          />
          <circle
            cx="200"
            cy="200"
            r="51"
            fill="#6c6c6c"
            style="filter:url(#dropshadow)"
          />
          <circle cx="200" cy="200" r="48" fill="#b3b2b2" />
          <path
            transform="rotate(90 200 200)"
            d="M.031 200.49c-.1-2.2.2-4.002.7-4.002l198.78-15.506c10.204-.8 19.308 7.603 19.608 18.908.3
            11.304-8.403 19.808-18.607 19.007L.932 204.492c-.4 0-.8-1.801-.9-4.002z"
            fill="#f3f3f3"
          />
          <path
            transform="rotate(90 200 200)"
            d="M49.051 200.49c0-1 .2-1.8.5-1.8l137.155-7.204c7.003-.4 13.205 3.402 13.305 8.404.1 5.002-6.002
            8.803-13.005 8.503l-137.455-6.102c-.2 0-.4-.8-.5-1.801z"
            fill="#c7c6c6"
          />
          <circle
            cx="200"
            cy="200"
            r="37"
            fill="#6d6d6c"
            style="filter:url(#dropshadow)"
          />
          <circle cx="200" cy="200" r="34" fill="#828282" />
          <circle cx="200" cy="200" r="14" fill="#fff" />
          <circle cx="200" cy="200" r="11" fill="#e9435f" />
        </svg>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'WeightScales',
  props: {
    value: { type: Number, default: 1 }
  },
  data() {
    return {
      svgStyle: {},
      sections: [],
      statuses: [
        {
          title: 'خیلی لاغر',
          color: '#4FC997'
        },
        {
          title: 'لاغر',
          color: '#F7C948'
        },
        {
          title: 'ایده آل',
          color: '#AE4BE2'
        },
        {
          title: 'چاقی درجه 1',
          color: '#ED58BC'
        },
        {
          title: 'چاقی درجه 2',
          color: '#F95070'
        },
        {
          title: 'چاقی مفرط',
          color: '#FF3E3E'
        }
      ]
    }
  },
  watch: {
    // value: {
    //   handler(val) {
    //     this.goTo(val)
    //   },
    //   immediate: true
    // }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      this.sections = []
      let parts = this.statuses.length
      let width = 400
      let degree = 360 / parts
      let start = 90
      const getSectorPath = function(x, y, outerDiameter, a1, a2) {
        const degToRad = Math.PI / 180
        const halfOuterDiameter = outerDiameter / 2
        const cr = halfOuterDiameter - 5
        const cx1 = Math.cos(degToRad * a2) * cr + x
        const cy1 = -Math.sin(degToRad * a2) * cr + y
        const cx2 = Math.cos(degToRad * a1) * cr + x
        const cy2 = -Math.sin(degToRad * a1) * cr + y
        return `M${x} ${y} ${cx1} ${cy1} A${cr} ${cr} 0 0 1 ${cx2} ${cy2}Z`
      }
      this.statuses.forEach((status, i) => {
        start -= degree

        let textTransform = `rotate(${degree * i +
          degree / 2} 200 200) translate(0, -167)`

        this.sections.push({
          area: {
            d: getSectorPath(
              width / 2,
              width / 2,
              width,
              start,
              start + degree
            ),
            fill: status.color
          },
          textTransform,
          content: status.title,
          marker: -start - degree / 2
        })
      })
    },
    goTo(index) {
      let degrees = 360 / this.sections.length
      degrees = -(index * degrees + degrees / 2)
      this.svgStyle = {
        transform: `rotate(${degrees}deg)`,
        transitionDuration: index * 0.5 + 2 + 's'
      }
    }
  }
}
</script>

<style lang="scss">
.weight-scales {
  border-bottom: solid 1px white;
  box-shadow: 0 6px 5px -6px rgba(0, 0, 0, 0.28);
  position: relative;
  width: 400px;
  max-width: 100%;
  margin-left: auto;
  margin-right: auto;
  padding: 0 20px;
  .weight-scales-inner {
    position: relative;
    overflow: hidden;
    &:before {
      display: block;
      content: '';
      padding-bottom: 50%;
    }
    .scale-svg-1 {
      transition: transform 2s ease-in-out;
    }
    .scale-svg-2 {
      padding: 12%;
    }
    .svg-outer {
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      svg {
        width: 100%;
        font-size: 1.5em;
        display: block;
      }
    }
  }
}
</style>
